////////////////////////////////////////////////////////////////////////
//                                                                    //
// Burkhard Militzer                                  Urbana 10-1-99  //
//                                                                    //
// Simple class to keep track of the acceptance ratios                //
//                                                                    //
////////////////////////////////////////////////////////////////////////

#ifndef _ACCRATIO_
#define _ACCRATIO_

#include "Standard.h"
#include "Form.h"

class AccRatio {
 public:
  int nTrial,nAccept; 
  string name;

  AccRatio():nTrial(0),nAccept(0) {};

  void Try() { nTrial++; }
  void Accept() { nAccept++; } 

  void Reset() { nTrial=0; nAccept=0; }
  double Ratio() const { return (nTrial>0) ? double(nAccept)/double(nTrial) : 0.0; }
  bool Flag() const { return nTrial>0; }

  void SetName(const string name_) {
    name = name_;
  }

  friend ostream& operator<<(ostream &os, const AccRatio & a) {
    os << " ";
    os << ( (a.name.length()>0) ? a.name : "Ratio ");
    os << " :";
    os << " tri=" << fix(8,0,a.nTrial);
    os << " acc=" << fix(8,0,a.nAccept);
    os << " ratio= " << fix(6,4,a.Ratio());
    os << endl;
    return os;
  }

};


#endif // _ACCRATIO_
